Installation de la stack
============

## Table des matières 
- 1. [Prérequis](#1-prérequis)
  - 1.a. [Création des dossiers](#1-a-création-des-dossiers)
  - 1.b. [Modifications des .env](#1-b-modifications-des-env)
  - 1.c Mise en place de la config .opvn
  - 1.d Optionnel - Création et Execution de /tun
- 2. Création des conteneurs
  - 2.a Création du réseau
  - 2.b Création des conteneurs
- 3. Les Bases
  - 3.a Commandes de bases ( docker )
  - 3.b Accès aux interfaces ( WebUI )
- 4. Configuration de rutorrent
  - 4.a Réactiver la fonction Effacer / Effacer et Supprimer les données
  - 4.b Sécuriser l’accès à l'interface
- 5. Aller plus loin
  - 5.b Rajouter les chemins vers ces médias
  - 5.c Mise à jour automatique ( watchtower )
  - 5.d Reboot automatique en cas de soucis ( autoheal )

## 1. Prérequis

- Cette stack est concu pour fonctionner dans un dossier downloads-vpn, avec l'architecture suivante :
```
             downloads-vpn ---- vpn ------------ config
                            |                 |_ scripts
                            |
                            |-- rutorrent ------ data
                            |                 |_ passwd
                            |                 |_ downloads
                            |
                            |-- prowlarr ------- config
                            |
                            |-- sonarr --------- config
                            |                 |_ downloads
                            |
                            |-- radarr --------- config
                            |                 |_ downloads
                            |
                            |-- jackett -------- config
                            |
                            |-- qbitorrent ----- config
                            |                 |_ downloads
```

- Dans le paragraphe 1.a nous allons les créer avec une ligne de commande, et dans le paragraphe 1.b nous allons modifier le .env afin qu'il utilise bien ces dossiers ( en fonction de leurs localisation sur votre machine ).

### 1.a. Création des dossiers

- Avec `cd` aller dans le dossier de votre choix, par exemple "docker".
Exemple : Si votre dossier "docker" ce trouve dans /volume1, alors la commande sera :
`cd /volume1/docker`

Maintenant que nous sommes dans le bon dossier, nous allons executer la commande suivante pour créer d'un coup, toute l'architecture nécessaire :

`mkdir -p downloads-vpn/vpn/{config,scripts} downloads-vpn/rutorrent/{data,passwd,downloads} downloads-vpn/prowlarr/config downloads-vpn/sonarr/{config,downloads} downloads-vpn/radarr/{config,downloads} downloads-vpn/jackett/config downloads-vpn/qbitorrent/{config,downloads}`

### 1.b. Modifications des .env

- Par defaut, il n'y a rien a modifier dans `rtorrent-rutorrent.env`.

- Dans le fichier `.env` vous allez devoir modifier plusieurs chose :

**PUID et PGID** devront correspondre aux ID de votre utilisateurs, plus d'info ici : [Connaitre le PUID / PGID d'un utilisateur](https://www.forum-nas.fr/viewtopic.php?f=56&t=13213)

**RACINE** correspond au chemin vers le dossier downloads-vpn créé a l'étape 1.a. Dans ce cas, c'est : `/volume1/docker/downloads-vpn`

### 1.c Mise en place de la config .opvn

- Dans notre dossier `downloads-vpn/vpn/config`, nous allons placer notre configuration .ovpn récupéré sur notre serveur OpenVPN.

**Note :** Si votre config VPN demande une identifications par mot de passe, alors il vous faudra modifier dans votre fichier .ovpn la ligne : 

```
auth-user-pass
```
par :
```
auth-user-pass /vpn/vpn.auth
```

Dans le dossier /volume1/docker/vpn/config en plus du fichier .ovpn, vous aller devoir créer un fichier vpn.auth contenant 2 lignes, sur la 1ere ligne, votre identifiant de connexion au VPN, et sur la 2eme ligne, votre mot de passe. 

**Exemple :**
```
votreidentifiantdeconnexion
votremotdepasse
```

### 1.d Optionnel - Création et Execution de /tun
- Si vous êtes sur un NAS de type Synology par exemple, alors la création du TUN est **obligatoire**

- Pour cela :
Recupérer le fichier `TUN.sh` présent, et placer le dans votre dossier `downloads-vpn`.

Vous devez être "root" pour l'executer, pour cela, passer en root avec sudo :
```
sudo su -
```

Puis rendez-vous dans le dossier contenant TUN.sh, dans mon cas `cd /volume1/docker/downloads-vpn`
```
cd /volume1/docker/downloads-vpn
```

on chmod le script pour le rendre executable :
```
chmod 0755 TUN.sh
```

et executer le script :
```
./TUN.sh
```

## 2. Création des conteneurs
### 2.a Création du réseau
### 2.b Création des conteneurs
